#include <windows.h>
#include <stdio.h>

void decrypt(BYTE *buf, const DWORD len)
{
  DWORD ebp_04;
  DWORD ebp_08;
  DWORD ebp_0C;
  DWORD ebp_10;

  __asm
  {
        mov eax, offset buf
        mov edx, len

        mov ecx, edx
        mov ebp_04, 0x136C9856  // constant may change
        mov ebp_08, 0x9ABFB3B6  // constant may change
        mov ebp_0C, 0x7F6A0DBB  // constant may change
        mov esi, eax
        mov eax, 0xBF4CD904     // constant may change
        mov ebp_10, eax
    L1: mov eax, ebp_04
        mov edx, ebp_08
        rol eax, 0x07
        rol edx, 0x1B
        xor eax, edx
        mov ebp_04, eax
        mov ebx, ebp_0C
        xor eax, ebx
        push ecx
        mov ecx, eax
        rol ebx, cl
        pop ecx
        ror eax, 0x0F
        xor edx, eax
        xor edx, ebx
        push ecx
        mov ecx, edx
        ror ebx, cl
        pop ecx
        mov ebp_0C, ebx
        mov ebp_08, edx
        mov ebx, ebp_04
        xor bl, byte ptr ds:[esi]
        mov eax, ebp_10
        xor bl, al
        mov byte ptr ds:[esi], bl
        push ecx
        mov ecx, edx
        ror eax, cl
        mov ebp_10, eax
        pop ecx
        inc esi
        dec ecx
        jnz L1
  }
}

void error(const char *format, ...)
{
  va_list paramList;
  va_start(paramList, format);
  vprintf(format, paramList);
  va_end(paramList);
  exit(EXIT_FAILURE);
}

long filesize(FILE *stream)
{
  long length;
  long curpos = ftell(stream);
  fseek(stream, 0L, SEEK_END);
  length = ftell(stream);
  fseek(stream, curpos, SEEK_SET);
  return length;
}

#pragma argsused
int main(int argc, char *argv[])
{
  FILE *raw;
  FILE *dfm;
  BYTE *buf;
  long  size;
  char  filename[MAX_PATH] = { 0x00 };

  GetFileTitle(argv[0], filename, sizeof(filename));

  if(argc != 3)
    error("Usage: %s someform.raw someform.dfm\n", filename);

  if((raw = fopen(argv[1], "rb")) == NULL)
    error("Unable to open %s.\n", argv[1]);

  if((dfm = fopen(argv[2], "wb")) == NULL)
    error("Unable to create %s.\n", argv[2]);

  size = filesize(raw) - 4;  // exclude first 4 bytes

  fseek(raw, 4, SEEK_SET);   // exclude first 4 bytes

  if((buf = (BYTE *)malloc(size)) == NULL)
    error("Out of memory!\n");

  if(!fread(buf, size, 1, raw))
    error("Read error!\n");

  decrypt(buf, size);

  if(!fwrite(buf, size, 1, dfm))
    error("Write error!\n");

  return 0;
}
